
/* 
 * unsigned FN_NAME(void * CONTROL,
 *             unsigned value0, unsigned ptr,
 *             unsigned decision);
 * 
 * r5 = cache control
 * r6 = value0
 * r7 = ptr
 * r8 = decision
 */

.globl FN_NAME
.text
FN_NAME:
    xori       r18, r8, 2       
    bneid      r18, 3f          /* decision != 2 */
    ori        r18, r0, 2       

    STORE      r6, r7, 0x0      /* Write, no cache */
    swi        r18, r5, 0xc     /* Cache control mode */
    LOAD       r0, r7, 0x0      /* Do invalidate */
    bri        4f

3:
    ori        r18, r0, 1
    swi        r18, r5, 0xc     /* Cache enable */
    beqid      r8, 0f           /* decision == 0 */
    addik      r8, r8, -1
    beqid      r8, 1f           /* decision == 1 */
    LOAD       r18, r7, 0x0     /* Read from cache (1st) */
    LOAD       r18, r7, 0x0     /* Read from cache (2nd) */
1:
0:
    STORE      r6, r7, 0x0      /* Write with cache (thru) */
    lwi        r18, r5, 0x10    /* Read Debug code */
    ori        r3, r18, 0
    swi        r0, r5, 0xc      /* Cache disable */
4:
    rtsd       r15, 8
    nop

